#include <jni.h>
#include <system/window.h>
#include <android/native_window.h>
#include "surfaceflinger_wrapper.h"
//----------------------------------------------------------------------------------------------------
#include <utils/Log.h>
#undef  LOG_TAG
#define LOG_TAG "HoFFPLAYJNI"
#if 1
#define gprintf(fmt, args...) LOGE("%s(%d): " fmt, __FUNCTION__, __LINE__, ##args)
#else
#define gprintf(fmt, args...)
#endif
//----------------------------------------------------------------------------------------------------

static ANativeWindow* theNativeWindow;

extern int engine_start(char* fname);

jboolean 
Java_net_hybridego_mm_hoffplay_HoffplayActivity_createStreamingMediaPlayer( JNIEnv* env, jobject thiz, jstring fname ) {
    gprintf("Call createStreamingMediaPlayer");
    
    const char *utf8 = (*env)->GetStringUTFChars(env, fname, NULL);
    gprintf("file name : %s", utf8);
    engine_start(utf8);
    return 1;
}

void 
Java_net_hybridego_mm_hoffplay_HoffplayActivity_shutdown( JNIEnv* env, jobject thiz) {
    gprintf("Call shutdown");
    // make sure we don't leak native windows
    if (theNativeWindow != NULL) {
        ANativeWindow_release(theNativeWindow);
        theNativeWindow = NULL;
    }
}

void 
Java_net_hybridego_mm_hoffplay_HoffplayActivity_setSurface( JNIEnv* env, jobject thiz, jobject surface) {
    gprintf("Call setSurface");
    theNativeWindow = ANativeWindow_fromSurface(env, surface);
    hovideo_setVideoSurface(theNativeWindow);
}
