package net.hybridego.mm.hoffplay;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.Surface;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.widget.Button;

public class HoffplayActivity extends Activity {
    static final String TAG = "HoFFPLAYJ";

    String mSourceString = null;
    String mSinkString = null;

    // member variables for native media player
    boolean mIsPlayingStreaming = false;
    SurfaceView mSurfaceView1;
    SurfaceHolder mSurfaceHolder1;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.main);

        // set up the Surface 1 video sink
        mSurfaceView1 = (SurfaceView) findViewById(R.id.surfaceview1);
        mSurfaceHolder1 = mSurfaceView1.getHolder();

        mSurfaceHolder1.addCallback(new SurfaceHolder.Callback() {

            public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
                Log.v(TAG, "surfaceChanged format=" + format + ", width=" + width + ", height=" + height);
            }

            public void surfaceCreated(SurfaceHolder holder) {
                Log.v(TAG, "surfaceCreated");
                setSurface(holder.getSurface());
                
            }

            public void surfaceDestroyed(SurfaceHolder holder) {
                Log.v(TAG, "surfaceDestroyed");
            }
        });

        // initialize content source spinner
        mSourceString = "/sdcard/NativeMedia.ts";

        // initialize button click handlers

        // native MediaPlayer start/pause

        ((Button) findViewById(R.id.start_native)).setOnClickListener(new View.OnClickListener() {
            boolean created = false;

            public void onClick(View view) {
                Log.e(TAG, "START !");
                if (!created) {
                    if (mSourceString != null) {
                        created = createStreamingMediaPlayer(mSourceString);
                    }
                }
            }
        });

        ((Button) findViewById(R.id.finish)).setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                finish();
            }
        });
    }

    /** Called when the activity is about to be paused. */
    @Override
    protected void onStop() {
        shutdown();
        super.onStop();
    }

    /** Native methods, implemented in jni folder */
    public static native boolean createStreamingMediaPlayer(String filename);
    public static native void shutdown();
    public static native void setSurface(Surface surface);

    /** Load jni .so on initialization */
    static {
        System.loadLibrary("hoffplay");
    }
}
